SystemOrganization addCategory: #EpisViewCourses!

Object subclass: #EVC_Course
	instanceVariableNames: 'codigo nombre creditos requisitos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!EVC_Course methodsFor: 'adding' stamp: 'ymq 11/8/2012 19:39'!
addRequisito: newRequisito
	"Agrega el codigo del curso que es requisito del actual"

	requisitos := requisitos,newRequisito! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:07'!
getCodigo
	"Retorna el codigo del curso"

	^ codigo! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:08'!
getCreditos
	"Retorna los creditos del curso"

	^ creditos ! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:07'!
getNombre
	"Retorna el nombre del curso"

	^ nombre! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 16:08'!
getRequisitos
	"Retorna los requisitos  del curso"

	^ requisitos ! !

!EVC_Course methodsFor: 'initialize-release' stamp: 'ymq 11/8/2012 19:09'!
initialize 
	"inicializa la super clase"

	super initialize .
	codigo := '0000' .
	nombre := 'desconocido' .
	creditos := 0.
	requisitos := #().
	! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:40'!
setCodigo: newCodigo
	"Cambiar codigo"

	codigo := newCodigo! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:41'!
setCreditos: newCreditos
	"Cambiar los creditos"

	creditos := newCreditos! !

!EVC_Course methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:40'!
setNombre: newNombre
	"Cambiar nombre de Curso"

	nombre := newNombre! !

Object subclass: #EVC_QueryGoogleDocs
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpisViewCourses'!

!EVC_QueryGoogleDocs methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 19:47'!
contentOf:url
	"Retorna un arreglo de Cursos obtenido de un JSON parseado, el cual proviene de la direccion  url"

	| parser json filas unit listCursos|
	
	parser := PPParserResource current parserAt: PPJsonParser.
	json := (Url absoluteFromText:url ) retrieveContents contents.
	result:= parser parse: json.
	
	filas :=  (result at:'feed')at: 'entry'.	
		
	listCursos := Array new: (filas size).
	(1 to: (filas size ))  do:  [
		:f |   | fila curso data cod nom cre req n m|
		curso := EVC_Course new.
		fila := filas at: f.
		data := (fila at: 'content') at:'$t'.
		
		cod := (fila at: 'title') at:'$t'.
		curso setCodigo: cod.
		
		n := data findString: ':'.
		m := data findString: ','.
		nom := data copyFrom: (n+2) to: (m-1).
		curso setNombre: nom.
		data :=  data copyFrom: (m+1) to: (data size ).
		
		n := data findString: ':'.
		m := data findString: ','.
		cre := (data copyFrom: (n+2) to: (m-1)) asNumber .
		curso setCreditos: cre.
		data:=  data copyFrom: (m+1) to: (data size ).
		
		n := (data findString: ':').
		data:= data copyFrom: (n+2) to: (data size ).
		
		(0 to: ((data size)//6)-1)do: [
			:i |  |pre str|
			pre := Array new: 1.
			str :=data copyFrom: ((6*i)+1) to: ((6*i)+6) .
			pre at: 1 put: str.
			curso addRequisito: pre.
			].
		
		listCursos at: f put: curso. 
		].
	^listCursos! !

!EVC_QueryGoogleDocs methodsFor: 'as yet unclassified' stamp: 'ymq 11/8/2012 15:06'!
initialize 
	"inicializa super clase"

	super initialize .! !
